//! bare3.rs
//! Simple bare metal application
//!
#![feature(used)]
#![no_std]

extern crate cortex_m;
extern crate cortex_m_rt;

#[macro_use]
extern crate cortex_m_debug;

fn main() {
    let s = "ABCD";
    ipln!("s = {:?}", s);

    // iterate over the byte repr. of s
    for c in s.as_bytes() {
        ip!("{},", c)
    }

    ipln!();
    loop {}
}

// As we are not using interrupts, we just register a dummy catch all handler
#[link_section = ".vector_table.interrupts"]
#[used]
static INTERRUPTS: [extern "C" fn(); 240] = [default_handler; 240];

extern "C" fn default_handler() {
    cortex_m::asm::bkpt();
}
